#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

int led_n[4]={898,899,900,901};
int btn_n[4]={902,903,904,905};

#define BUFSIZE 256

FILE *led_fp[4];
FILE *btn_fp[4];
FILE *fp;
char filename[BUFSIZE];

int open_gpios(){
  int i;
  sprintf(filename,"/sys/class/gpio/export");
  fp=fopen(filename,"w");
  if (fp==NULL){
    fprintf(stderr,"can't open %s\n",filename);
    exit(-1);
  }
  for (i=0;i<4;i++) fprintf(fp,"%d\n",led_n[i]);
  for (i=0;i<4;i++) fprintf(fp,"%d\n",btn_n[i]);
  fclose(fp);

  for (i=0;i<4;i++) {
    sprintf(filename,"/sys/class/gpio/gpio%d/direction",led_n[i]);
    fp=fopen(filename,"w");
    if (fp==NULL){
      fprintf(stderr,"can't open %s\n",filename);
      exit(-1);
    }
    fprintf(fp,"out");
    fclose(fp);
  }

  for (i=0;i<4;i++) {
    sprintf(filename,"/sys/class/gpio/gpio%d/direction",btn_n[i]);
    fp=fopen(filename,"w");
    if (fp==NULL){
      fprintf(stderr,"can't open %s\n",filename);
      exit(-1);
    }
    fprintf(fp,"in");
    fclose(fp);
  }

  for (i=0;i<4;i++) {
    sprintf(filename,"/sys/class/gpio/gpio%d/value",led_n[i]);
    led_fp[i]=fopen(filename,"w");
    if (led_fp[i]==NULL){
      fprintf(stderr,"can't open %s\n",filename);
      exit(-1);
    }
  }

  for (i=0;i<4;i++) {
    sprintf(filename,"/sys/class/gpio/gpio%d/value",btn_n[i]);
    btn_fp[i]=fopen(filename,"r");
    if (btn_fp[i]==NULL){
      fprintf(stderr,"can't open %s\n",filename);
      exit(-1);
    }
  }
  return 0;
}

int close_gpios(){
  int i;
  for (i=0;i<4;i++) fclose(led_fp[i]);
  for (i=0;i<4;i++) fclose(btn_fp[i]);
  return 0;
}

int main(int argc, char **argv){
  char buf[BUFSIZE];
  int val;

  open_gpios();

  fgets(buf,BUFSIZE-1,btn_fp[0]);val=atoi(buf);printf("BTN[%d]=%d\n",0,val);
  fprintf(led_fp[0],"1"); fflush(led_fp[0]);
  sleep(1);

  fgets(buf,BUFSIZE-1,btn_fp[1]);val=atoi(buf);printf("BTN[%d]=%d\n",1,val);
  fprintf(led_fp[1],"1"); fflush(led_fp[1]);
  sleep(1);

  fgets(buf,BUFSIZE-1,btn_fp[2]);val=atoi(buf);printf("BTN[%d]=%d\n",2,val);
  fprintf(led_fp[2],"1"); fflush(led_fp[2]);
  sleep(1);

  fgets(buf,BUFSIZE-1,btn_fp[3]);val=atoi(buf);printf("BTN[%d]=%d\n",3,val);
  fprintf(led_fp[3],"1"); fflush(led_fp[3]);
  sleep(1);

  fprintf(led_fp[0],"0");
  fprintf(led_fp[1],"0");
  fprintf(led_fp[2],"0");
  fprintf(led_fp[3],"0");

  close_gpios();

  return 0;
}
